module SaikyoLine
  module Acts
    module Fortuned
      def self.included(base)
        base.extend ActMethods
      end

      module ActMethods
        def acts_as_fortuned
          self.extend ClassMethods
          self.instance_eval {include InstanceMethods}

          before_save :cast
        end
      end

      module ClassMethods
        # No methods defined in here.
      end

      module InstanceMethods
        def cast
          if self.respond_to? 'fortune='
            fortunes = %w(大吉 吉 中吉 小吉 凶)
            self.fortune = fortunes[rand(fortunes.length)]
          end
        end
      end
    end
  end
end
